''*******************************************************************
''*       Title: VGA display 40x15 (single cog, ROM font, palette)  *
''*    FileName: VGA_40x15_demo.spin                                *
''* Description: Demonstration of 40x15 VGA display functions       *
''*      Author: Marko Lukat (c) 2013                               *
''*******************************************************************
'' Revision History
''-----------------
''   Release: 2013/10/01 - Version: 0.1.pal.1 - by Marko Lukat 
''     (original) initial version (640x480@60Hz timing, %11 sync locked)
''   Release: 2013/10/05 - Version: 0.2.pal.4 - by Marko Lukat  
''        (1) change: unknown
''   Release: 2013/10/11 - Version: 0.3.pal.4 - by PropGuy2 
''        (2) changed filename to: VGA_40x15_demo.spin 
''        (3) added OBJ: Simple_Numbers.spin
''        (4) changed "PUB selftest" to: "PUB MAIN"
''        (5) update & rework: PUB MAIN
''        (6) update & rework: PRI fill(char, mode{boolean})
''        (7) added palette(0) color reference table 
''-----------------
''
CON
  _clkmode        = xtal1 + pll16x    'PLL Multiplier
  _xinfreq        = 5_000_000         'XTAL Frequency
  
VAR
 word valX, c, ii, JJ
 
OBJ
  vga   : "VGA_40x15_display"
  SN_   : "Simple_Numbers"
     
PUB MAIN                              'Start Demo program

  vga.init                            'Initialize VGA display driver
  vga.str(string($03 ))               'set Page(S) scroll function 

  vga.setn(1, @pal0)                  'Switch to palette 0
  vga.str(string($C,%1111_0000))      'Color =Black  /White
 'vga.str(string($01 ))               'set Screen color/home
 'vga.str(string($FF ))               'set Screen color/home
  vga.out($FF )                       'set Screen color/home
  c := 0                              'Character index =0
  repeat vga#bcnt -1                  'Character screen fill 
     vga.putc(c++)
  waitcnt(clkfreq*4 + cnt)
  
  vga.setn(1, @pal1)                  'Override to Palette 1
  fill(vga.str(string($C, %1100_0000)), FALSE) 'Red  characters
  fill(vga.str(string($C, %1010_0000)), FALSE) 'Green characters
  fill(vga.str(string($C, %1001_0000)), FALSE) 'Blue characters

  vga.setn(1, @pal0)                  'Switch to palette 0  
  fill(0, TRUE)                       'Goto Cursur Home
  waitcnt(clkfreq*3 + cnt)

  repeat 32                           'Rotate palette 0 (16..31)
     c := pal0[31]                    'Rotate palette 0 (16..31)                       
     bytemove(@pal0[17], @pal0[16], 15)                 
     pal0[16] := c                    'Rotate palette 0 (16..31)    
     repeat 15                        'Update palette 0 
        vga.setn(1, @pal0)            'Update palette 0

  vga.setn(1, @pal0)                  'Switch to palette 0 
 '%binary___  dec  Letter /BGround    'for Palette(0) ONLY  
 '%0000_1111  15d  Black  /White  OK
 '%0000_1110  14d  Black  /Yellow OK
 '%1111_0000  240  White  /Black  OK  
 '%1111_1000   +8  White  /Black  1   'binary(%) & decimal(d)
 '%1111_1001   +9  White  /Blue   2   'palette(0) color table
 '%1111_1010  +10  White  /Green  3   '1st foreground.letters
 '%1111_1011  +11  White  /LTblue 4   '2nd background.color
 '%1111_1100  +12  White  /Red    5   'example:
 '%1111_1101  +13  White  /Pink   6   '%1100_1001 = 201 decimal
 '%1111_1110  +14  White  /Yellow 7   'red letters /blue background
 '%0000_1111  15d  Black  /White  8
                                     
  vga.str(string($C,%0000_1110))      'Color =Letter /BGround
  vga.str(string($01 ))               'Color =Black  /Yellow
  vga.str(string( "ClrScreen =Yellow ")) 
      waitcnt(clkfreq*4 + cnt)       

  vga.str(string($C,%0000_1111))      'Color =Black  /White     
  vga.str(string($01 ))               'set Screen color/home
  vga.str(string($C, 14, "SetScreen =White "))    
      waitcnt(clkfreq*4 + cnt)        
   
  vga.str(string($C,%0000_1111))      'Color =Black  /White
  vga.str(string($01 ))               'set Screen color/home
  c := 0                              'Character index =0 
  repeat vga#bcnt -1                  'Character screen fill
     vga.putc(c++)
  waitcnt(clkfreq*4 + cnt)           
  
  vga.setn(1, @pal0)                  'Switch to palette 0
  vga.str(string($C,%0000_1011))      'Color =Black  /White
  vga.str(string($01 ))               'set Screen color/home

  
  vga.str(string($A,6,$B,1,$C, %0000_1010 , "* multi ",$C,%1001_1100, "colored "))   
  vga.str(string($C,%1111_1101 , "test ",$C,%1100_1001 , "message ")) 

  ii := 6
  JJ := 3
  valX := 123 
  vga.gotoXY(6,JJ)                    'set screen Cursor(X,Y)
  vga.str(string($C,%1111_0000, "* Number format test = ")) 
  vga.str(SN_.decx(valX,6))           'formatted Simple_Numbers
  vga.textXY(ii,JJ+2,string($C,%1111_1100,"* textXY format",32,"command ",32,79,75,32))
  vga.out(259)                        'output Character to screen
' return - END of Demo program  
  
PRI fill(char, mode{boolean})
  vga.str(string($02 ))               'set Screen home
  repeat vga#bcnt -1
     if mode                          'Mode =True
       vga.str(string($C ))     '     '  set character colors
       vga.out(char)                  '  and Rotate colors
    vga.putc(char++)                  'Mode =False
    waitcnt(clkfreq/99 + cnt)         '  set character colors
''return

DAT                                   'Color Pallette (0)

pal0    byte    %%0000, %%0010, %%0100, %%0110
        byte    %%1000, %%1010, %%1100, %%1110
        byte    %%0000, %%0030, %%0300, %%0330
        byte    %%3000, %%3030, %%3300, %%3330
                                              
        byte    %%0000, %%0010, %%0100, %%0110
        byte    %%1000, %%1010, %%1100, %%1110
        byte    %%0000, %%0030, %%0300, %%0330
        byte    %%3000, %%3030, %%3300, %%3330

DAT                                    'Color Palette (1)

pal1    byte    %%0220[8]
        byte    %%0000, %%0030, %%0300, %%0330
        byte    %%3000, %%3030, %%3300, %%3330

        byte    %%0010[8]
        byte    %%0000[8]

DAT               